/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2007 by IBM Corporation */

if(!dojo._hasResource["zero.ide.widget.appmgr.AdminCoreIde"]){
dojo._hasResource["zero.ide.widget.appmgr.AdminCoreIde"] = true;
dojo.provide("zero.ide.widget.appmgr.AdminCoreIde");
dojo.requireLocalization("zero.ide.widget.appmgr", "AdminCoreIdeNls");

dojo.require('dijit.Dialog');
dojo.require('dijit.form.Button');
dojo.require('dijit.layout.AccordionContainer');
dojo.require('dijit.layout.ContentPane');
dojo.require('dijit.layout.LayoutContainer');
dojo.require('dijit.layout.SplitContainer');
dojo.require('dijit._Templated');
dojo.require('dijit._Widget');

dojo.require('dojox.uuid.generateRandomUuid');

dojo.declare("zero.ide.widget.appmgr.AdminCoreIde",
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appmgr/templates/AdminCoreIde.html"),
    
    _inSelectionListener: false,
	admin: true,
    finishButton: null,
    progressCancelCallback: null,
	progressDialog_zIndex: null, 
	navshown : true,
	hideDlgComplete: null,
    
    cancel: function()
    {
    },
    
    next: function()
    {
        this.interactionArea.forward();
    },
    
    back: function()
    {
        this.interactionArea.back();
    },

	setController: function(pController)
    {
        this._controller = pController;
        //this.fileDialogConn = dojo.connect(this._controller,'doShowCreateFileDialog', this,'doShowCreateFileDialog');
    },


    showProgressDlg: function(/*String*/msg, /* Function (optional) */ cancelCallback)
    {
        // Set message
        this.progressMessage.innerHTML = msg;

		// Display cancel button if a cancel callback is present.
		if (cancelCallback) {
			this.progressCancelButton.domNode.style.display = "block";
			this.progressCancelCallback = cancelCallback;
		}
		
        // Show the dialog
		this.progressDialog.domNode.style.zIndex = this.progressDialog_zIndex++; //ensure we are at the highest z-index
		if(zlog.isDebug())console.debug("AdminCoreIde: showProgressDlg, Show progressDialog.show(). Args= "+msg + " z-index= " 
		                                +this.progressDialog_zIndex);
        this.progressDialog.show();
    },

    hideProgressDlg: function()
    {
        this.progressDialog.hide();
        
        if (this.progressCancelCallback) {
        	this.progressCancelCallback = null;
        	this.progressCancelButton.domNode.style.display = "none";
        }
    },
    
    addFinishButton: function(pLabel, pContext, pFunction)
    {
        this.finishButton = new dijit.form.Button({label: pLabel},
                                                  this.finishButtonDiv);
        this.finishButton.domNode.style.display = 'none';
        dojo.connect(this.finishButton, 'onClick', pContext, pFunction);
    },

    addInteraction: function(pInteractionWidget, pNavigationWidget,
                             pRemoveFromParent)
    {
        this._navigationInteractionMap[pInteractionWidget] = pNavigationWidget;
        this._navigationInteractionMap[pNavigationWidget] = pInteractionWidget;
        
        if (pRemoveFromParent)
        {
            pInteractionWidget.domNode.parentNode.removeChild(pInteractionWidget.domNode);
            pNavigationWidget.domNode.parentNode.removeChild(pNavigationWidget.domNode);
        }
        
        this.interactionArea.addChild(pInteractionWidget);
        this.navigationArea.addChild(pNavigationWidget);
        
        this.resize();
    },
    
    selectInteraction: function(pInteractionWidget)
    {
        if (this.interactionArea.selectedChildWidget != pInteractionWidget)
        {
            this.interactionArea.selectChild(pInteractionWidget);
        }
        else
        {
            // Fake it. Escpecially for the Back and Next buttons.
            this._onInteractionSelected(pInteractionWidget);
        }
    },

    
    resize: function(sizew)
    {
		if(zlog.isDebug()){console.debug("AdminCoreIde.resize, Computing size of interactionArea ")};
		this.splitContainer.resize(sizew);

        this.interactionAreaSplitContainer.resize();//resize area(top and botttom panes)
		if (this.interactionAreaSplitContainer.isCollapsed()){//2nd pane is minimized
		    //restore scroll position to bottom
		    this.buildLogArea.domNode.scrollTop = this.buildLogArea.domNode.scrollHeight; //scroll to bottom to see appended results
		}
		
		var args = null;
		try {
			var outerbox = this.splitContainer._contentBox;
			if (this.rightPaneTopContent) {
			  var upperbox = dojo.marginBox(this.rightPaneTopContent);
			  args = {h: outerbox.h - upperbox.h};
			} else {
			  args = {h: outerbox.h};
			}
		} catch (e) {
			if(zlog.isDebug())console.debug("AdminCoreIde: resize, Error computing size of interacrionArea "+e);
		}
        this.interactionArea.resize(args);
        this.navigationArea.resize();
    },

    
    hideNav: function()
    {
        if(zlog.isDebug())console.debug("in hideNav this.navigationArea = ");
		if(zlog.isDebug())console.debug(this.navigationArea);
		if(zlog.isDebug())console.debug(this.splitContainer);
        if(zlog.isDebug())console.debug("in hideNav this.navigationArea.sizeShare = "+this.navigationArea.sizeShare);		

		if (undefined == this.savedNavSize) {
			this.savedNavSize = 20; 
		}
        if (!this.navshown) {
			return;
		}

        this.savedNavSize = this.navigationArea.sizeShare;
        if(zlog.isDebug())console.debug("in hideNav this.savedNavSize set to = "+this.savedNavSize);		

        // this section is a hack to avoid a problem with the scrollpane
		// after moving the splitter the outOf gets very large, and our sizeShare has to change 
		var outOf = 0;
		dojo.forEach(this.splitContainer.getChildren(), function(child){
			outOf += child.sizeShare;
		});
        if(zlog.isDebug())console.debug("in hideNav XXXX outOf = "+outOf);
        if (outOf > 500) {
		   this.navigationArea.sizeShare = 18;
		} else {
    		this.navigationArea.sizeShare = 1.4;
		}


		this.resize();

        this.splitContainer.layout();		
		this.navshown = false;
    },
    
    showNav: function()
    {
        if(zlog.isDebug())console.debug("AdminCoreIde.showNav: in showNav this.navigationArea = ");
		if(zlog.isDebug())console.debug(this.navigationArea);
		if(zlog.isDebug())console.debug(this.splitContainer);
        if(zlog.isDebug())console.debug("in showNav this.navigationArea.sizeShare = "+this.navigationArea.sizeShare);		
        if(zlog.isDebug())console.debug("in showNav this.navigationArea.navshown being shown is =."+this.navshown);		

		if (this.navshown) {
			return;
		}
        if(zlog.isDebug())console.debug("in showNav this.navigationArea.savedNavSize = "+this.savedNavSize);		

		if (undefined == this.savedNavSize || this.savedNavSize < 10) {
			this.savedNavSize = 20; 
		}

//        this.interactionArea.sizeShare = this.interactionArea.sizeShare - (this.savedNavSize - 6);
		//if (!undefined == this.savedNavSize) {
		  this.navigationArea.sizeShare = this.savedNavSize;
        //}
        if(zlog.isDebug())console.debug("in showNav set this.navigationArea.sizeShare = "+this.navigationArea.sizeShare);		

        //this.splitContainer._updateSize();
//		var children = this.splitContainer.getChildren();
//        if(zlog.isDebug())console.debug("in hideNav children[0] = ");

//        if(zlog.isDebug())console.debug(children[0]);
        this.resize();

		this.splitContainer.layout();
		   
		this.navshown = true;
    },

	editMainOut: function(evt ) {
           if(zlog.isDebug())console.debug(" editMainout: leaving main ");
		   if(zlog.isDebug())console.debug(evt);
		   alert(" editMainOut: leaving ");
		   
    },
	
	editMainOver: function(evt ) {
           if(zlog.isDebug())console.debug(" editMainOver: leaving ");
		   alert(" editMainOver: leaving ");
		   if(zlog.isDebug())console.debug(evt);
/*		   var test = this.coreIde.domNode;
		   if(zlog.isDebug())console.debug(test);
		   var obj = evt.target;
		   if (obj != test) {
	        if(zlog.isDebug())console.debug(" inside the while loop");
		     while (obj.parentNode !== null && obj.parentNode !== test &&
			        obj.parentNode.id !== "editNavId")
		     {
			    obj = obj.parentNode;
				if(zlog.isDebug())console.debug(obj);
		     }
           }
	        if(zlog.isDebug())console.debug(" after the while loop");
            if(zlog.isDebug())console.debug(obj);
		   if (obj.parentNode.id == "editNavId") {
			  if(zlog.isDebug())console.debug(" editNavOut found nav id, leave it showing ");

			  return;
		   }
*/		   
		   this.hideNav();
//           if (dojo) {
//		     dojo.stopEvent(evt);
//             dojo.removeClass(this.editNavNode, "editNav-itemrowHover");
//		   }
         //  if(zlog.isDebug())console.debug(" editNavout: exit");
        },

    
    getInteractionAreaSize: function()
    {
        var box = dojo.marginBox(this.interactionArea.domNode);
        return {h:box.h, w:box.w};
    },
    
    showCancel: function(pShown)
    {
        this.cancelButton.domNode.style.display = (pShown ? 'block' : 'none');
    },
    
    _onNavigationSelected: function(page)
    {
        if (this._inSelectionListener)
        {
            return;
        }
        this._inSelectionListener = true;
        this.interactionArea.selectChild(this._navigationInteractionMap[page]);
        this._inSelectionListener = false;
    },
    
    _onInteractionSelected: function(page)
    {
        if (undefined !== page.onDisplayed  &&
                    'function' == typeof(page.onDisplayed))
        {
            page.onDisplayed();
        }
        var children = this.interactionArea.getChildren();
        this.backButton.setDisabled(page == children[0]);
        if (null === this.finishButton)
        {
            this.nextButton.setDisabled(page == children[children.length-1]);
        }
        else
        {
            if (page == children[children.length-1])
            {
                this.nextButton.domNode.style.display = 'none';
                this.finishButton.domNode.style.display = 'block';
            }
            else
            {
                this.nextButton.setDisabled(false);
                this.nextButton.domNode.style.display = 'block';
                this.finishButton.domNode.style.display = 'none';
            }
        }
        if (this._inSelectionListener)
        {
            return;
        }
        this._inSelectionListener = true;
//        this.navigationArea.selectChild(this._navigationInteractionMap[page]);
        this._inSelectionListener = false;
    },
    
    _addRemoveHorizScroll: function()
	{
		if (this.interactionAreaSplitContainer.isCollapsed()){//2nd pane has been minimized
		    if (dojo.hasClass(this.buildLogArea.domNode,"logInfoAreaWithOverflow-x")){
				//remove the overflow class when status window is collaped
				dojo.removeClass(this.buildLogArea.domNode, "logInfoAreaWithOverflow-x");
		    }
		}else{
		    if (!dojo.hasClass(this.buildLogArea.domNode,"logInfoAreaWithOverflow-x")){//add if class does not exist
				//add the overflow class, status window has been expanded
				dojo.addClass(this.buildLogArea.domNode, "logInfoAreaWithOverflow-x");
		    }
		}
		this.resize();//resize and add data to content window		
    },

    _progressCancelButtonClicked: function()
	{
    	if (this.progressCancelCallback) {
    		this.progressCancelCallback();
    	}
    	this.hideProgressDlg();
    },
    
    _progressDlgDone: function()//when progressDlg has been hidden, update build log area and disconnect
    {
		if(zlog.isDebug()){console.debug("AdminCoreIde._progressDlgDone, disconnect event & update status window ")};

		if ( this.hideDlgComplete){
			dojo.disconnect(this.hideDlgComplete);
			this.hideDlgComplete = null;
		}
		setTimeout(dojo.hitch(this, "scrollBuildLogArea"),1000, false);//update the content area and scroll to bottom of text
		
    },

    scrollBuildLogArea: function(isInitialData)//when progressDlg has been completed OR initial data, update build log area
    {
		if(zlog.isDebug()){console.debug("AdminCoreIde.scrollBuildLogArea, scroll window pane. isInitialData= "+isInitialData)};

		if ( this.hideDlgComplete === null || isInitialData){
	        this.interactionAreaSplitContainer.resize();//resize area(top and botttom panes)
			this.buildLogArea.setContent(this.buildLogData);
			if (this.interactionAreaSplitContainer.isCollapsed()){//2nd pane is minimized
			    //restore scroll position to bottom
			    this.buildLogArea.domNode.scrollTop = this.buildLogArea.domNode.scrollHeight; //scroll to bottom to see appended results
			}
		}
    },
    startup: function()
    {
		if(zlog.isDebug()){console.debug("AdminCoreIde.startup: setup interactionArea ")};
        zero.ide.widget.appmgr.AdminCoreIde.superclass.startup.apply(this, arguments);
        this.progressDialog.titleBar.style.display = 'none';
        this.progressDialog_zIndex = 100000; //start off with a high zindex for modal dialog
    },
        
    postMixInProperties: function()
    {
        zero.ide.widget.appmgr.AdminCoreIde.superclass.postMixInProperties.apply(this, arguments);
        
        		this.messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AdminCoreIdeNls", this.lang);
        
        this._uid = dojox.uuid.generateRandomUuid();
    },

    // Dojo Attach Points
    backButton: null,
    cancelButton: null,
    finishButtonDiv: null,
    interactionArea: null,
    navigationArea: null,
    nextButton: null,
    progressDialog: null,
    progressCancelButton: null,
    progressMessage: null,
    splitContainer: null
    
    // DojoEvent Stubs
}
);
}