/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
/* Copyright (c) 2008 by IBM Corporation */

if(!dojo._hasResource["zero.ide.widget.appmgr.AppListRow"]){
dojo._hasResource["zero.ide.widget.appmgr.AppListRow"] = true;
dojo.provide("zero.ide.widget.appmgr.AppListRow");

dojo.require('dijit.Tooltip');
dojo.require("zero.ide.widget.environment._AppContextMenu");
dojo.requireLocalization("zero.ide.widget.appmgr", "AppListRowNls");


dojo.declare("zero.ide.widget.appmgr.AppListRow",
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appmgr/templates/AppListRow.html"),

		// settings
		datarow : "",
		admin : false,
        messages:"",
        id: "",
        name: "",
        path: "",
		rootUri: "",
        description: "",
        module_group: "",
        isRunning: "",
		isRunnable: "",
        last_accessed: "",
        tags: "",
        showDescription : "", 
        created: "",
		imagePath: dojo.moduleUrl("zero","ide/images"),
		calledRunOrStop: false,

        //widget(s)
		deleteAppDialogWidget: null,
		
		postCreate: function() {
		   if(zlog.isDebug())console.debug("AppListRow.postCreate: name " + this.datarow.name );
         
           this.inherited("postCreate", arguments);		   

           this._showDescription(this.showDescription); 
		   if(zlog.isDebug())console.debug("catalog ListRow setListRow : EXIT this.name = " + this.name +" this.showDescription ="+this.showDescription );

		   this.setAppStatus(this.isRunning);
		   if (this.admin) {
		   	  dojo.style(this.appListRowEditNode, "display", "none");
		   	  dojo.style(this.appListRowMoveLinkNode, "display", "none");
		   	  dojo.style(this.appListRowCopyLinkNode, "display", "none");
		   	  dojo.style(this.appListRowLinkExportNode, "display", "none");
              dojo.style(this.appListRowDescriptionNode, "display", "none");
              dojo.style(this.appListRowDescriptionNode2, "display", "none");
		   }

		   if(zlog.isDebug())console.debug("AppListRow.postCreate: exit");
		},
    
		startup: function()
    	{
           //setup the popup menu for right clicks
           this.inherited("startup", arguments);		   
		   //create a popup menu for this application
 		   if (!this.admin) {
		       this.newWindowMenu = new zero.ide.widget.environment._AppContextMenu({targetNodeIds: [this.appListRowNameNode.id], id:this._uid +"-appListMenu"});
		       this.newWindowMenu.addChild(new dijit.MenuItem({label:this.messages.openNewWindow, onClick:dojo.hitch(this,this.menuItemClicked) }));
			   if(dojo.isFF ){ 
				   this.newWindowMenu.addChild(new dijit.MenuItem({label:this.messages.openNewTab, onClick:dojo.hitch(this,this.menuItemClicked) }));
			   }
		       this.newWindowMenu.startup();
		   }
		},		
	    
		postMixInProperties: function()
	    {
	        //zero.ide.widget.appmgr.AppListRow.superclass.postMixInProperties.apply(this, arguments);
	       this.inherited('postMixInProperties', arguments);

		   this.messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppListRowNls", this.lang);

           this._uid = dojox.uuid.generateRandomUuid();
		   
           this.setListRow();
           //this.starSelected = false;
	 
	    },
		
		setListRow: function() {
		   if(zlog.isDebug())console.debug("AppListRow.setListRow : ENTER this.name = " + this.name );
		   if(zlog.isDebug())console.debug(this.datarow );

           if (this.name === "") { this.name = this.datarow.name; }
           if (this.path === "") { this.path = this.datarow.path; }
           if (this.rootUri === "") { this.rootUri = this.datarow.rootUri; }
           if (this.description === "") { this.description = this.datarow.description; }
           if (this.module_group === "") { this.module_group = this.datarow.modulegroup; }
           if (this.last_accessed === "") { this.last_accessed = this.datarow.last_accessed; }
           if (this.tags === "") { this.tags = this.datarow.tags; }
           if (this.isRunning === "") { this.isRunning = this.datarow.isRunning; }
           if (this.isRunnable === "") { this.isRunnable = this.datarow.isRunnable; }
           if (this.id === "") { this.id = "app-list-row-ui-"+this.datarow.id; }
           if (this.showDescription === "") { this.showDescription = true; }

		   
		   return; //for now
		},

		_handleFilter: function(filterVal) {
           if(zlog.isDebug())console.debug(" ListRow _handleFilter ENTER: filterVal =" + filterVal + "  -  name is "+this.name );
           if (this._showItemRow(filterVal)) {
		   	  //show the row 
              dojo.style(this.appListRowNode, "display", "");
		   } else {  // hide the row
              if(zlog.isDebug())console.debug(" ListRow _handleFilter Hide this row: filterVal =" + filterVal + "  -  name is "+this.name );
              dojo.style(this.appListRowNode, "display", "none");
		   }
		},
		
		_showItemRow: function(filterval) {
			var val = filterval.toLowerCase();
			if (this.name && this.name.toLowerCase().lastIndexOf(val) !== -1) {
				return true;
			}
			if (this.path && this.path.toLowerCase().lastIndexOf(val) !== -1) {
				return true;
			}
			if (this.rootUri && this.rootUri.toLowerCase().lastIndexOf(val) !== -1) {
				return true;
			}
			if (this.description && this.description.toLowerCase().lastIndexOf(val) !== -1) {
				return true;
			}
			if (this.module_group && this.module_group.toLowerCase().lastIndexOf(val) !== -1) {
				return true;
			}
			if (this.tags && this.tags.toLowerCase().lastIndexOf(val) !== -1) {
				return true;
			}

            return false;
        },

        
		_showDescription: function(showDesc ) {
           if(zlog.isDebug())console.debug(" AppListRow showDescription ENTER: showDesc =" + showDesc + "  -  name is "+this.name );
           this.showDescription = showDesc;
		   this.tempShowDescription = null;
           if (this.showDescription) {
		   	   if (this.admin) {
                  dojo.style(this.adminListRowExpandNode, "display", "");
			   } else {
                  dojo.style(this.appListRowDescriptionNode, "display", "");
                  dojo.style(this.appListRowDescriptionNode2, "display", "");
			   }
               //dojo.addClass(this.listRowNode, "itemrowshowdescription");
           } else {
		   	   if (this.admin) {
                  dojo.style(this.adminListRowExpandNode, "display", "none");
			   } else {
                  dojo.style(this.appListRowDescriptionNode, "display", "none");
                  dojo.style(this.appListRowDescriptionNode2, "display", "none");
			   }
               //dojo.removeClass(this.listRowNode, "itemrowshowdescription");
           }
           if(zlog.isDebug())console.debug(" AppListRow showDescription EXIT : showDesc =" + showDesc );
		},

		setAppStatus: function(bAppStatus) {
           if(zlog.isDebug())console.debug("AppListRow.setAppStatus - Application status, running= : " + bAppStatus+" runnable : "+this.isRunnable);
	       this.isRunning = bAppStatus;
           if (this.calledRunOrStop) {
			    currentApplication = null; 
			    this.calledRunOrStop = false;
		   }
		   
           // do this so sort will have the update
		   dijit.byId('app-mgr-ui-id')._controller.saveAppStatus(this.datarow.id,bAppStatus);   
           
		   if (bAppStatus) { 
			  //this.appListRowRunStoplinkNode.innerHTML = "Stop";
		  	  dojo.removeClass(this.appListRowRunStoplinkNode, "zeroListRowRunButton");
        	  dojo.addClass(this.appListRowRunStoplinkNode, "zeroListRowStopButton");
			  this.appListRowRunStoplinkNode.title = this.messages.stop;
			  
			  //set the green icon - started
              //if ( dojo.hasClass(this.appListStatusIconImageNode, "zeroRunningIcon") ){
			  //   return;//already displaying the right status
			  //}
		  	  dojo.removeClass(this.appListStatusIconImageNode, "zeroStoppedIcon");
        	  dojo.addClass(this.appListStatusIconImageNode, "zeroRunningIcon");
			  this.appListStatusIconImageNode.title = this.messages.running;

              dojo.addClass(this.appListRowRootUri, "zeroListRowRootUri");
              if (this.appListRowRootUri.domNode) {
			     this.appListRowRootUri.domNode.tabIndex = 0;
              }
		   }else{
			  //this.appListRowRunStoplinkNode.innerHTML = "Run";
		  	  dojo.removeClass(this.appListRowRunStoplinkNode, "zeroListRowStopButton");
        	  if (this.isRunnable) {
	        	  dojo.removeClass(this.appListRowRunStoplinkNode, "zeroListRowRunButtonDisabled");
				  dojo.addClass(this.appListRowRunStoplinkNode, "zeroListRowRunButton");
				  this.appListRowRunStoplinkNode.title = this.messages.run;
                  dojo.removeClass(this.appListRowRootUri, "zeroListRowRootUri");
				  dojo.style(this.appListRowRootUri, "display", "");
				  dojo.style(this.appListRowNotRunnable, "display", "none");

			  } else {
	        	  dojo.addClass(this.appListRowRunStoplinkNode, "zeroListRowRunButtonDisabled");
				  this.appListRowRunStoplinkNode.title = this.messages.run_disabled;
				  dojo.style(this.appListRowRootUri, "display", "none");
				  dojo.style(this.appListRowNotRunnable, "display", "");
			  }
			  
              //set the red icon - stopped
              //if ( dojo.hasClass(this.appListStatusIconImageNode, "zeroStoppedIcon") ){
			  //	  return; //already displaying the right status
			  //}
			  dojo.removeClass(this.appListStatusIconImageNode, "zeroRunningIcon");
        	  dojo.addClass(this.appListStatusIconImageNode, "zeroStoppedIcon");
  			  this.appListStatusIconImageNode.title = this.messages.not_running;

              dojo.removeClass(this.appListRowRootUri, "zeroListRowRootUri");
              if (this.appListRowRootUri.domNode) {
			      this.appListRowRootUri.domNode.tabIndex = -1;
			  }
		   }
        },

		updateAppInfo: function(entry) {
           var bAppStatus = entry.isRunning;
		   if(zlog.isDebug())console.debug("AppListRow.updateAppInfo - Application status, new running : " + bAppStatus+" new runnable : "+entry.isRunnable+" app name : "+entry.name);
		   if(zlog.isDebug())console.debug("AppListRow.updateAppInfo - Application status, old running : " + this.isRunning+" old runnable : "+this.isRunnable+" app name : "+this.name);

	       //this.isRunning = bAppStatus;
           if (this.calledRunOrStop) {
			    currentApplication = null; 
			    this.calledRunOrStop = false;
		   }
		   this.datarow = entry;

		   if (this.appListRowNameNode.innerHTML !== this.datarow.name) {
		   	  // update the app name 
			  this.name = this.datarow.name;
			  this.appListRowNameNode.innerHTML = this.name;
		   }
		   if (this.appListRowPathNode.innerHTML !== this.datarow.path) {
		   	  // update the app path
			  this.path = this.datarow.path; 
			  this.appListRowPathNode.innerHTML = this.path; 
		   }
		   if (this.appListRowRootUri.innerHTML !== this.datarow.rootUri ) {
		   	  // update the app rootUri
			  this.rootUri = this.datarow.rootUri; 
			  this.appListRowRootUri.innerHTML = this.rootUri;
		   }
		   if (this.appListRowDescription.innerHTML !== this.datarow.description) {
		   	  // update the app description
			  this.description = this.datarow.description; 
			  this.appListRowDescription.innerHTML = this.description;
		   }
		   if (this.appListRowModuleGroup.innerHTML !== this.datarow.modulegroup) {
		   	  // update the app module_group
			  this.module_group = this.datarow.modulegroup;
			  this.appListRowModuleGroup.innerHTML = this.module_group; 
		   }
		   if (this.isRunning !== this.datarow.isRunning || 
		       this.isRunnable !== this.datarow.isRunnable) {
		   	  // update the app isRunning and isRunnable
			  this.isRunning = this.datarow.isRunning;
			  this.isRunnable = this.datarow.isRunnable;
			  
			  this.setAppStatus(this.isRunning); 
		   }

           this.last_accessed = this.datarow.last_accessed;
           this.tags = this.datarow.tags;
		   
           // do this so sort will have the update
		   dijit.byId('app-mgr-ui-id')._controller.saveAppStatus(this.datarow.id,bAppStatus);   
        },

		getId: function() {
           if(zlog.isDebug())console.debug("AppListRow.getId() = " + this.id);
		   return this.id;
        },


		setFocusToLink: function() {
           if(zlog.isDebug())console.debug("AppListRow.setFocusToLink() = " + this.id);
		   this.appListRowTagsNode.focus();
		   this.appListRowRootUri.focus();
		   this.appListRowNameNode.focus();
		   
        },

	    processEvent: function(evt)
	    {
	        if (evt.target.id === "appListRowEditNode" || evt.target.id === "listRowNode")
	        {
	            this.itemEdit();
	        }else
              if (evt.target.id === "appListRowRunStoplinkNode")
	          {
			  	if (this.isRunnable) {                                          
	                this.itemLaunchApplication();
				}
	          }else
                if (evt.target.id === "appListRowDelLinkNode")
	            {
	                this.itemConfirmAppRemove();
	            }else
                  if (evt.target.id === "appListRowMoveLinkNode")
	              {
		                dojo.publish("MgrListRowAction", [{pAction: "move", 
						                                   appId: this.datarow.id,
														   appName: this.datarow.name,
						                                   appPath: this.datarow.path,
						                                   appModuleGroup: this.datarow.modulegroup,
						                                   appDescription: this.datarow.description}]);
				  	
	              }else
                    if (evt.target.id === "appListRowCopyLinkNode")
	                {
		                dojo.publish("MgrListRowAction", [{pAction: "copy", 
						                                   appId: this.datarow.id,
														   appName: this.datarow.name,
						                                   appPath: this.datarow.path,
						                                   appModuleGroup: this.datarow.modulegroup,
						                                   appDescription: this.datarow.description}]);
						
	                }else
                       if (evt.target.id === "appListRowLinkExportNode")
	                   {
		                dojo.publish("MgrListRowAction", [{pAction: "export", 
						                                   appId: this.datarow.id,
														   appName: this.datarow.name,
						                                   appPath: this.datarow.path,
						                                   appModuleGroup: this.datarow.modulegroup,
						                                   appDescription: this.datarow.description}]);

	          }

	    },
		
	    itemEdit: function()
	    {
           //launch the editor
			dijit.byId('app-mgr-ui-id')._controller.open(this.datarow);

	    },

	    itemLaunchApplication: function()
	    {
		   if(zlog.isDebug())console.debug("AppListRow.itemLaunchApplication - BEGIN");
		   currentApplication = this.datarow;
		   this.calledRunOrStop = true;
		   if(zlog.isDebug())console.debug("AppListRow.itemLaunchApplication - this.isRunning = "+this.isRunning );
            if (this.isRunning){ //app running, user want to stop it
				dijit.byId('app-mgr-ui-id')._controller.stop();
		    	//this.setAppStatus(false); //update icon to red( stopped) and set linktext to "Run" since we justed stopped it 
			}else{ //was stopped, user wants to start app
				dijit.byId('app-mgr-ui-id')._controller.run(false);
		    	// elc wait on successful start to go green
				//this.setAppStatus(true); //update icon to green( started ) and set linktext to "Stop"  
			}
			
		},

	    itemConfirmAppRemove: function()
	    {
		   if(zlog.isDebug())console.debug("AppListRow.itemConfirmAppRemove - BEGIN");
	       if ( this.deleteAppDialogWidget === null ){
             this.deleteAppDialogWidget = new zero.ide.widget.appmgr.DeleteAppDialog( 
                         {  "id": "del-app-dlg-ui-"+this.datarow.id,
						    "appId": this.datarow.id,
						    "appName": this.datarow.name,
						    "appPath": this.datarow.path,
                            "messages":"" },
                       dojo.byId("deleteAppDlg"+this.datarow.id) ); 
			}
		   this.deleteAppDialogWidget.show();
		   if(zlog.isDebug())console.debug("AppListRow.itemConfirmAppRemove - EXIT");
		},

/*
 * 
 * ItemRow Node Functions
 * 
 */
		listrowlinkClick: function(evt) {
		   if(zlog.isDebug())console.debug("AppListRow.listrowlinkClick : name : " + this.name );
           dojo.stopEvent(evt);
           this.processEvent(evt);
        },

		listrowEditClick: function(evt) {
		   if(zlog.isDebug())console.debug("AppListRow.listrowEditClick : name : " + this.name );
           if (!this.admin) {
              this.itemEdit();
		   }
        },


		listrowRootUriClick: function(evt) {
		   if(zlog.isDebug())console.debug("AppListRow.listrowRootUriClick : name : " + this.name );
		   if (!this.isRunnable){
		   	//popup dialog and show the details why application NOT runnable
			 var notRunnableDlg = dijit.byId('app-mgr-notrunnable-ui-id');
             notRunnableDlg.getNotRunnableInfo(this.datarow.id);
			 return;
		   }else{
			  if (!this.isRunning){
		   		return;//app not running...return
		   	  }
		   }
            var appUri = this.rootUri;
			if(zlog.isDebug())console.debug("listrowRootUriClick: appUri =  "+appUri);
		    window.open (appUri, '_blank');
			return false;
        },


		listrowlinkOnKey: function(evt ) {
           if(zlog.isDebug())console.debug("AppListRow.ListRowlistrowlinkOnKey name : " + this.name  + " evt.charCode ="+evt.charCode);
           if (evt.charCode == dojo.keys.SPACE || evt.keyCode == dojo.keys.ENTER) {
             //dojo.stopEvent(evt);

		   if(zlog.isDebug())console.debug(" AppListRow listrowlinkOnKey : ENTER key is " + this.key);
           this.processEvent(evt);
          }
        },

		listrowlinkOver: function(evt ) {
           if(zlog.isDebug())console.debug("AppListRow.listrowlinkOver: enter -> name : " + this.name );
           //dojo.stopEvent(evt);
	   
           //if(zlog.isDebug())console.debug("AppListRow.listrowlinkOver over: evt : " + evt );
           //if(zlog.isDebug())console.debug( evt );
           //dojo.addClass(this.appListRowExportNode, "listrow-itemrowHover");
		   if (this[evt.target.id]) {
             dojo.addClass(this[evt.target.id], "listrowlinkHover");
		   }
           
           //if(zlog.isDebug())console.debug(" ListRowover: EXIT");
		},

		listrowlinkOut: function(evt ) {
         //  if(zlog.isDebug())console.debug("AppListRow.listrowlinkOut: leaving -> name : " + this.name );
          //dojo.stopEvent(evt);
          //dojo.removeClass(this.appListRowExportNode, "listrowlinkHover");
		   if (this[evt.target.id]) {
              dojo.removeClass(this[evt.target.id], "listrowlinkHover");
           }

        },

		listrowlinkOnFocus: function(evt ) {
           if(zlog.isDebug())console.debug("AppListRow.listrowlinkOnFocus name : " + this.name +" this[evt.target.id]= "+this[evt.target.id] );
           //dojo.stopEvent(evt);
           //dojo.addClass(this.appListRowExportNode, "listrow-itemrowHover");
		   if (this[evt.target.id]) {
             dojo.addClass(this[evt.target.id], "listrowlinkHover");
		   }

        },

		listrowlinkOnBlur: function(evt ) {
           if(zlog.isDebug())console.debug("AppListRow.listrowlinkOnBlur name : " + this.name +" this[evt.target.id]= "+this[evt.target.id]);
           //dojo.stopEvent(evt);
           //dojo.removeClass(this.appListRowExportNode, "listrow-itemrowHover");
		   if (this[evt.target.id]) {
              dojo.removeClass(this[evt.target.id], "listrowlinkHover");
           }
         },
		 

		 listrowFaviconClick: function(evt ) {
           if(zlog.isDebug())console.debug("AppListRow.listrowFaviconClick name : " + this.name + "this.tempShowDescription = "+this.tempShowDescription);
           dojo.stopEvent(evt);
		   if (this.tempShowDescription !== null) {
		      this.tempShowDescription = !this.tempShowDescription;	
		   } else {
		   	  this.tempShowDescription = !this.showDescription
		   }
           if (!this.tempShowDescription) {
               if(zlog.isDebug())console.debug("AppListRow.listrowFaviconClick setting description display none "+this.tempShowDescription);
		   	   if (this.admin) {
                  dojo.style(this.adminListRowExpandNode, "display", "none");
			   } else {
                  dojo.style(this.appListRowDescriptionNode, "display", "none");
                  dojo.style(this.appListRowDescriptionNode2, "display", "none");
               }
           } else {
               if(zlog.isDebug())console.debug("AppListRow.listrowFaviconClick setting description display on "+this.tempShowDescription);
		   	   if (this.admin) {
                  dojo.style(this.adminListRowExpandNode, "display", "");
			   } else {
                  dojo.style(this.appListRowDescriptionNode, "display", "");
                  dojo.style(this.appListRowDescriptionNode2, "display", "");
			   }
           }


         },

        clearNode: function(node) {
 	       //if(zlog.isDebug())console.debug("catalog ListRow clearNode: ENTER node is " + node );
 	       var count = 0;
           if (node) {
             for (var i = 0; i < node.childNodes.length; i++) {
                node.removeChild(node.childNodes[i]);
                count++;
             }       
           }           
 	       //if(zlog.isDebug())console.debug("catalog ListRow clearNode: EXIT number removed was " + count );
        },   

        clear: function() {
	       if(zlog.isDebug())console.debug("catalog ListRow clear: enter id is " + this.id +" clear - postCreate" );
           this.clearNode(this.listRowNode);
           this.clearNode(this.appListRowDescriptionNode);
           this.clearNode(this.appListRowDescriptionNode2);
           this.clearNode(this.appListRowName);
           this.clearNode(this.appListRowcomment_count);
           this.clearNode(this.appListRowDescription);
           this.clearNode(this.appListRowTypeName);
//         this.clearNode(this.appListRowOwnerName);
//         this.clearNode(this.appListRowRating);
        },
         
	    destroy: function() 
		{
			if(zlog.isDebug())console.debug("AppListRow: destroy");
			if ( this.deleteAppDialogWidget ){
				this.deleteAppDialogWidget.destroy();
				this.deleteAppDialogWidget = null;
			}
			return this.inherited('destroy',arguments);	
        },

		menuItemClicked: function(evt)
		{
		   if(zlog.isDebug())console.debug("AppListRow:menuItemClicked - evt= ");
	       if(zlog.isDebug())console.debug(evt);
		   //build up the URL to run in a seperate browser window
		   var targetedUri = "";
	   	   var loc = window.location.toString();
			//only interested in everything before #view and then we'll set rest of url...
	   	   var rootUri = decodeURIComponent(loc).split("#view=");
           //build URL to open new brower window
           targetedUri = rootUri[0]+ "#view" +encodeURIComponent("=AppEditor+app="+this.datarow.id+"+uiview=allFilesView");

	        //open new browser window or new window in a tab.  
	       openNewWindow(evt.currentTarget.sectionRowIndex==1,targetedUri);
		   
		},

        lastMethod : function () {
           // this method does not have a comma after it
        }
	}
	
);

}



