/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2007 by IBM Corporation */

if(!dojo._hasResource["zero.ide.widget.appmgr.CommonLinkedContainer"]){
dojo._hasResource["zero.ide.widget.appmgr.CommonLinkedContainer"] = true;
dojo.provide("zero.ide.widget.appmgr.CommonLinkedContainer");

dojo.require('dijit.layout.StackContainer');
dojo.require('dijit._Container');
dojo.require('dijit._Templated');
dojo.require('dijit._Widget');
dojo.require('dojox.uuid.generateRandomUuid');

dojo.declare("zero.ide.widget.appmgr.CommonLinkedContainer",
             [dijit._Widget, dijit._Container, dijit._Templated],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appmgr/templates/CommonLinkedContainer.html"),
    
    _linkClicked: function(pLinkWidget)
    {
        var page = this._linkInteractionMap[pLinkWidget];
        this.interactionArea.selectChild(page);
        
        if (undefined != page.onDisplay  &&  typeof(page.onDisplay) == 'function')
        {
            page.onDisplay();
        } 
    },
    
    startup: function()
    {
        zero.ide.widget.appmgr.CommonLinkedContainer.superclass.startup.apply(this, arguments);
        
        this._linkInteractionMap = {};
        
        var children = this.getChildren();
        for (var i=0  ;  i < children.length  ;  i++)
        {
            children[i].domNode.parentNode.removeChild(children[i].domNode);
            
            if (undefined != children[i].createLink  && 
                        typeof(children[i].createLink) == 'function')
            {   
                dojo.connect(children[i], 'onLinkClicked', this, '_linkClicked');
                
                var groupChildren = children[i].getChildren();
                if (0 != groupChildren.length)
                {
                    for (var j=0  ;  j < groupChildren.length  ;  j++)
                    {
                        groupChildren[j].domNode.parentNode.removeChild(groupChildren[j].domNode);
                        this.interactionArea.addChild(groupChildren[j]);
                        
                        var link = children[i].createLink(groupChildren[j].title);
                        this._linkInteractionMap[link] = groupChildren[j];
                        this._linkInteractionMap[groupChildren[j]] = link;
                    }
                    children[i].containerNode.style.display = 'none';
                }
                if (0 != i)
                {
                    children[i].domNode.style.marginTop = '1em';
                }
                this.commandArea.appendChild(children[i].domNode);
            }
            else
            {
                this.instructionsArea.appendChild(children[i].domNode);
            }
        }
        
        this.interactionArea.resize();
    },
    
    // dojo Attach points
    commandArea: null,
    interactionArea: null,
    instructionsArea: null,
    layoutContainer: null,
    linkArea: null
});

dojo.declare("zero.ide.widget.appmgr.CommonLinkedContainerLinkGroup",
             [dijit._Widget, dijit._Container, dijit._Templated],
{
    widgetsInTemplate: true,
    templateString:
    [
        '<fieldset>',
            '<legend>${legend}</legend>',
            '<ul class="list" dojoAttachPoint="linkArea">',
            '</ul>',
            '<div dojoAttachPoint="containerNode" style="padding: 0px;">',
            '</div>',
        '</fieldset>'
    ].join(' '),
    
    legend: '',
    _links: 0,
    
    createLink: function(pLinkText)
    {
        var div = document.createElement('div');
        var link = new zero.ide.widget.appmgr.CommonLinkedContainerLink(
                                    {text: pLinkText}, div);
        link.startup();
        dojo.connect(link, 'onLinkClicked', this, '_linkClicked');
                
        if (this._links == 0)
        {
            link.hilite(true);
            this._selectedLink = link;
        }
        this.linkArea.appendChild(link.domNode);
        this._links++;
        
        return link;
    },
    
    _linkClicked: function(pLinkWidget)
    {
        this._selectedLink.hilite(false);
        this._selectedLink = pLinkWidget;
        
        this.onLinkClicked(pLinkWidget); 
    },
    
    linkArea: null,
    
    onLinkClicked: function(pWidget) {}
});

dojo.declare("zero.ide.widget.appmgr.CommonLinkedContainerLink",
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
    templateString:
    [
        '<li>',
            '<a href="javascript:void(0)" class="command-link"',
                'dojoAttachPoint="theLink"',
                'dojoAttachEvent="onclick:linkClicked">',
                '${text}',
            '</a>',
        '</li>'        
    ].join(' '),
    
    linkClicked: function(e)
    {
        this.onLinkClicked(this);
        this.hilite(true);
    },
    
    hilite: function(pHilite)
    {
        this.theLink.className = 
                pHilite ? 'selected-link command-link' : 'command-link';
    },
    
    theLink: null,
    
    onLinkClicked: function(widget) {}
});
}