/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */

if(!dojo._hasResource["zero.ide.widget.appmgr.DeleteAppDialog"]){
dojo._hasResource["zero.ide.widget.appmgr.DeleteAppDialog"] = true;
dojo.provide("zero.ide.widget.appmgr.DeleteAppDialog");

dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require('dijit._Templated');
dojo.require('dijit._Widget');
dojo.require("dojox.uuid.generateRandomUuid");

dojo.requireLocalization("zero.ide.widget.appmgr", "CommonAppDialogNls");

dojo.declare("zero.ide.widget.appmgr.DeleteAppDialog",
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appmgr/templates/DeleteAppDialog.html"),

	messages: null,
   	appId: null,
   	appName: null,
   	appPath: null,
	admin: true,

    getAppName: function()
    {
        return this.appName;
    },
    	
    getPath: function()
    {
        return this.appPath;
    },

    show: function()
    {
		if (this.admin){
			dojo.style(this.appDeleteContentsNode, "display", "none");
		}
		this.appDeleteDialog.show();
        
        // set timeout to allow the browser to render dialog
        setTimeout(dojo.hitch(this, function() {
                this.delButton.focus();
            }), 200);
    },
    
	hide: function() {
        this.appDeleteDialog.hide();
	},
	
    doConfirmOnKey: function(pEvent)
    {
 	    if(zlog.isDebug())console.debug("DeleteAppDialog:doConfirmAction() - User hit key, perfom action");
        if (pEvent.keyCode == dojo.keys.ENTER) //remove from AppList and delete dir
        {						
            dojo.stopEvent(pEvent);
			this._removeApp();
        }
    },
    
    postMixInProperties: function()
    {
        zero.ide.widget.appmgr.DeleteAppDialog.superclass.postMixInProperties.apply(this, arguments);

		this.messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "CommonAppDialogNls", this.lang);
        
        this._uid = dojox.uuid.generateRandomUuid();
    }, 
	
	_appDeleted: function (response, ioArgs) 
	{		
		var manager = dijit.byId('app-mgr-ui-id');	
		manager._ideWidget.hideProgressDlg();

		manager.refresh();					
		return response;
	},
	
	_appDeleteError: function (response, ioArgs) 
	{
		var manager = dijit.byId('app-mgr-ui-id');			
		manager._ideWidget.hideProgressDlg();
		
		//manager._statusDialog.showDialog('Error', '', ioArgs.xhr.responseText);
		//var t = eval('(' + ioArgs.xhr.responseText + ')');
		manager._statusDialog.showDialog('Error', '', dojo.string.substitute(this.messages.error_deleting_app));
		//manager._statusDialog.showDialog('Error', '', eval('(' + ioArgs.xhr.responseText + ')').errorMessage);
		
		manager.refresh();  // go ahead and refresh in case the app was already gone		
		return response;	
	},			
	
	_removeApp: function ()
	{
        this.appDeleteDialog.hide();
		// Give the display time a bit to hide/fade dialog, then do xhr calls
        setTimeout(dojo.hitch(this, function() {
                this._appDelete();
            }), 200);
	},

	_appDelete: function ()
	{
  		var manager = dijit.byId('app-mgr-ui-id')
        manager._ideWidget.showProgressDlg(dojo.string.substitute(this.messages.error_deleting_app));

		var url = null;
		if ( !this.admin && this.appDelCheckbox.checked ){
            url = '/resources/applications/'+this.appId;
		}
		else{
            url = '/resources/applications/'+this.appId+'?metadata';
		}
  		
		var paramsObj = {  
        	url: url,
	    	load: dojo.hitch(this, this._appDeleted),    
        	error: dojo.hitch(this, this._appDeleteError),
			preventCache: true,
		    handleAs: "text"        
		}		
		dojo.xhrDelete(paramsObj);
	},
	    
    // Dojo attach Points
    appDeleteDialog: null


}
);
}    